/*
 *
 * Copyright 2017 Asylo authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#include <gmock/gmock.h>
#include <gtest/gtest.h>
#include "asylo/test/util/enclave_test.h"
#include "asylo/test/util/status_matchers.h"

namespace asylo {
namespace {

class ExhaustSgxTcsTest : public EnclaveTest {};

TEST_F(ExhaustSgxTcsTest, StdThreadResourceExhausted) {
  EXPECT_THAT(client_->EnterAndRun({}, nullptr),
              StatusIs(error::GoogleError::RESOURCE_EXHAUSTED));
}

}  // namespace
}  // namespace asylo
